from rocolib.api.components.Component import Component

c = Component()

c.addSubcomponent("servo", "MountedServo")
#fs90r is the continous servo that we are using. Check dimensions.py in rocolib to check other servo motors
c.addParameter("driveservo", "fs90r", paramType="dimension")

c.addConstraint(("servo", "servo"), "driveservo")

#To make it longer adjust that "+4"
c.addConstraint(("servo", "length"), "driveservo", 'getDim(x, "motorlength") + 10')
c.addConstConstraint(("servo", "center"), False)

c.addParameter("beltLength", 75, paramType="length")

for i in range(4):
    c.addSubcomponent("belt%d" %i, "Rectangle")
    c.addConstraint(("belt%d"%i, "l"), "beltLength")
    c.addConstraint(("belt%d"%i, "w"), "driveservo", 'getDim(x, "motorheight")')

c.addConnection(("belt0", "l"), ("servo", "beam.botedge1"), angle=90)
c.addConnection(("belt1", "l"), ("servo", "beam.botedge3"), angle=90)
c.addConnection(("belt2", "l"), ("servo", "beam.topedge1"), angle=90)
c.addConnection(("belt3", "l"), ("servo", "beam.topedge3"), angle=90)

c.toLibrary("CarHingeServo")