from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addSubcomponent("boat", "BoatWithStackBattery", inherit=True)
c.inheritAllInterfaces("boat")

# c.addParameter("length", 130, paramType="length")
# c.addParameter("width", 90, paramType="length")
# c.addParameter("depth", 70, paramType="length")
#
# c.addConstraint(("boat", "boat.length"), "length")
# c.addConstraint(("boat", "boat.width"), "width")
# c.addConstraint(("boat", "boat.depth"), "depth")

#DC Mounts
for i in range(4):
    c.addSubcomponent("dcMount%d" %i, "DCMotorMount", inherit=True)
    c.addConstraint(("dcMount%d" %i, "mountWidth"), "boat.width")
    c.addConstraint(("dcMount%d" %i, "supportLength"), "boat.depth")

#Split Edges
for i in range(4):
    c.addSubcomponent("split%d" %i, "SplitEdge")
    c.addConstConstraint(("split%d" %i, "toplength"), (180,))
    c.addConstConstraint(("split%d" %i, "botlength"), (40, 10, 40, 40, 10, 40)) #symmetric

#connections to each of the DC mounts
c.addConnection(("dcMount0", "leftArmInterface"), ("split0", "botedge1"), tabWidth=6)
c.addConnection(("dcMount0", "rightArmInterface"), ("split1", "botedge1"))

c.addConnection(("dcMount1", "leftArmInterface"), ("split0", "botedge4"), tabWidth=6)
c.addConnection(("dcMount1", "rightArmInterface"), ("split1", "botedge4"))

c.addConnection(("dcMount2", "leftArmInterface"), ("split2", "botedge1"), tabWidth=6)
c.addConnection(("dcMount2", "rightArmInterface"), ("split3", "botedge1"))

c.addConnection(("dcMount3", "leftArmInterface"), ("split2", "botedge4"), tabWidth=6)
c.addConnection(("dcMount3", "rightArmInterface"), ("split3", "botedge4"))

# c.addConnection(("split0", "botedge2"), ("dcMount%d" %i, "rightArmInterface"))
# c.addConstraint(("split0", "botlength"), ("topDistance", "botDistance"), "(x[0]-5, 10, x[1]-5)")
# c.addConstraint(("split1", "botlength"), ("topDistance", "botDistance"), "(x[1]-5, 10, x[0]-5)")
#
c.addConnection(("boat", "porttopsplit"), ("split0", "topedge0"))
c.addConnection(("boat", "portbotsplit"), ("split2", "topedge0"))
c.addConnection(("boat", "startopsplit"), ("split1", "topedge0"))
c.addConnection(("boat", "starbotsplit"), ("split3", "topedge0"))
#
# c.addConnection(("dcMount","rightArmInterface"), ("split0", "botedge1"), angle=-180)
# c.addConnection(("dcMount","leftArmInterface"), ("split1", "botedge1"), tabWidth=5, angle=-180)

c.toLibrary("BoatWithManyDCMounts")
