import pytest
import logging
from rocolib.library import getComponent, pyComponents, yamlComponents, allComponents, rebuild, rebuildComponent


def test_rebuild(c = None):
    if c:
        rebuildComponent(c)
    else:
        rebuild()

@pytest.mark.parametrize("component",pyComponents)
def test_component_python(component):
    getComponent(component).test()

@pytest.mark.parametrize("component",yamlComponents)
def test_component_yaml(component):
    getComponent(component).makeOutput(default=False)

if __name__ == "__main__":
    logging.basicConfig(level=logging.INFO)
    test_rebuild()
